﻿using System;
using System.Threading;

class Program
{
    static void Main(string[] args)
    {
        new WorkItem(5, 0);

        ThreadPool.QueueUserWorkItem(workFunc, 6);

        Console.ReadLine();
    }

    static void workFunc(object state)
    {
        Console.WriteLine(state);
    }

    class WorkItem
    {
        public int Arg;
        System.Threading.Timer _timer;

        public WorkItem(int arg, int interval)
        {
            Arg = arg;
            _timer = new System.Threading.Timer(timerCallback, this, interval, 0);
        }

        private static void timerCallback(object state)
        {
            WorkItem workItem = state as WorkItem;

            try
            {
                if (workItem == null)
                {
                    return;
                }

                //int tryCount = 5;
                //while (workItem._timer == null && tryCount-- > 0)
                //{
                //    Thread.Sleep(10);
                //}

                if (workItem._timer == null)
                {
#if DEBUG
                    throw new ApplicationException("workItem._timer == null");
#else
                    return;
#endif
                }

                Console.WriteLine(workItem.Arg);

                workItem._timer.Dispose();
            }
            catch
            {
                return;
            }
        }
    }
}
